#define BSIZE           (4096*2)
#define NUMBUFFERS      (8)
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <unistd.h>
#include <GLUT/glut.h>
#include "ct.h"

#include <OpenAL/alc.h>
#include <OpenAL/al.h>
#include "alut.h"
#include "wave.h"
//=====GLUT
int screen_width,screen_height, icenterx,icentery;
int x,y;
void  display(void);
void  processMouse(int button, int state, int x, int y );
void  processMouseMotion( int x, int y );
void  processKeyboard(unsigned char key, int x,int y);
void  init(void);
void  idle();

static GLfloat light_ambient[]  = { 0.0, 0.0, 0.0, 1.0 };
static GLfloat light_diffuse[]  = { 1.0, 1.0, 1.0, 1.0 };
static GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };
//static GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };
static GLfloat light_position[] = { 0.0, 1.0, 1.0, 0.0 };

static GLfloat mat_ambient[]    = { 0.7, 0.7, 0.7, 1.0 };
static GLfloat mat_diffuse[]    = { 0.8, 0.8, 0.8, 1.0 };
static GLfloat mat_specular[]   = { 1.0, 1.0, 1.0, 1.0 };
static GLfloat high_shininess[] = { 100.0 };
//=====GLUTEND
//=====AL
//GLOBAL-------------
float SIGNAL[2][BSIZE],TIME[BSIZE];  //PLOT VARIABLES
float bufy[BSIZE];
int N,N2;
ALuint Buffer;
ALuint Source;
//source position
ALfloat SourcePos[] ={0.0,0.0,0.0};
ALfloat SourceVel[] ={0.0,0.0,0.0};
//Listener position
ALfloat ListenerPos[]={0.0,0.0,0.0};
ALfloat ListenerVel[]={0.0,0.0,0.0};
ALfloat ListenerOri[]={0.0,-1.0,0.0,0.0,1.0,0.0};
//pointer to wave file
WAVE_Struct     wave;
FILE            *fp;                    
// PROCESS VARS
char            file[] = {"Bass2.wav"};
ALbyte          DATA   [BSIZE];
ALuint          Buffers[NUMBUFFERS];
ALuint          BufferID;
ALuint          DataSize;
ALuint          DataToRead;
ALint           processed;
ALboolean       bFinished = AL_FALSE;
ALuint          Format;
ALint           State;
ALuint    buffersreturned=0;
ALboolean bFinishedPlaying = AL_FALSE;
ALuint    buffersinqueue = NUMBUFFERS;
//-------------------
FILE * OPENWAVEFILE ( ALbyte *, WAVE_Struct *, int );
void PREBUFFER();
void SETLOCATION();
//=====ALEND


/*========================================== */
int main(int argc, char** argv) {
extern int screen_width,screen_height, icenterx,icentery;

/*++GLUT++++++++++++++++++++++++++++++++++++*/
        screen_width=WIDTH;
        screen_height=HEIGHT;
        icenterx = (screen_width)/ 2 ;
        icentery = (screen_height)/ 2 ;

        glutInit(&argc, argv);
        glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB );
        glutInitWindowSize(screen_width,screen_height);
        glutInitWindowPosition(0,0);
        glutCreateWindow(" Ain't No Mountain High Enough ");

        glutDisplayFunc(display);
        glutKeyboardFunc(processKeyboard);
        glutMouseFunc(processMouse);
        glutMotionFunc(processMouseMotion);
        init();
        glutIdleFunc(idle);
        glutMainLoop();
/*++++++++++++++++++++++++++++++++++++++*/


	return 0;
}
/*==================================================*/
/*=======================================================*/
FILE * OPENWAVEFILE ( ALbyte *filename, WAVE_Struct *wave, int size)
{
 FILE *fp;
 extern ALuint DataSize;
 extern ALuint Format;
 extern int N,N2;

 fp = fopen( filename,"rb");
 if (fp==NULL) 
  {
	printf ("can not open wavefile %s\n",filename); 
	return NULL; 
  }
  if (fread(wave,1,size,fp) !=(unsigned)size)
  {
	printf(" can not read file header\n");
	fclose(fp);
	return NULL;
  }
//==========
printf("wave->riff= %cif%c\n",wave->riff[0],wave->riff[3]);
printf("wave->wave= %cav%c\n",wave->wave[0],wave->wave[3]);
printf("wave->fmt= %cm%c\n",wave->fmt[0],wave->fmt[2]);


printf("wave->Channels= %d\n",wave->Channels);
printf("wave->SamplesPerSec= %d\n",wave->SamplesPerSec);
printf("wave->BytesPerSec = %d\n",wave->BytesPerSec );
printf("wave->BitsPerSample = %d\n",wave->BitsPerSample );
printf("wave->dataSize= %d\n",wave->dataSize);
//===========
// data needed is GLOBAL
// DataSize, Format,N2,N
	DataSize=wave->dataSize;
	if (wave->BitsPerSample ==16)
	{
    	  if(wave->Channels == 1) 
	    Format = AL_FORMAT_MONO16;
          else
	    Format = AL_FORMAT_STEREO16;

          N2 = BSIZE/wave->Channels;
          N  = N2/2;
        } 
	else
	{
	  printf (" GET INFO WAVEFILE not 16 bit\n");
	 return NULL;
	}
  return fp;
}
//-------------------
//-------------------
//-------------------
//-------------------
/*========================================== */
//-------------------
// PREBUFFER
void PREBUFFER()
{
int i,j,k;
extern float SIGNAL[2][BSIZE],TIME[BSIZE];
extern int N,N2;
static short *m;

    if ( DataSize==wave.dataSize) //none read yet
     {
	for(k=0; k <NUMBUFFERS;k++)
	{
	fread(DATA,1 , BSIZE,fp);
	DataSize= DataSize -BSIZE;
        //=FILTER======================
		m = (short *)DATA;
		for (j=0;j<wave.Channels;j++)
		{
		  for (i=0;i< N;i++){
			SIGNAL[j][i]  = m[wave.Channels*i+j]; 	//WIN
			}

		  for (i=0;i< N;i++){
			m[wave.Channels*i+j] =(short)SIGNAL[j][i]; 
			}
		}
        //=FILTER END======================
	alBufferData(Buffers[k],Format,DATA,BSIZE,wave.SamplesPerSec);
	}
     }

}
/*========================================== */
void SETLOCATION ()
{
//source features
alSourcef (Source, AL_GAIN,     1.0);
alSourcef (Source, AL_PITCH,    1.0);
alSourcefv(Source, AL_POSITION, SourcePos);
alSourcefv(Source, AL_VELOCITY, SourceVel);
//listener position
alListenerfv( AL_POSITION,    ListenerPos);
alListenerfv( AL_VELOCITY,    ListenerVel);
alListenerfv( AL_ORIENTATION, ListenerOri);
if(alGetError() != AL_NO_ERROR) printf("3\n");
}
//-------------------
//-------------------
//-------------------
//-------------------
//-------------------


/***********************************/
/***********************************/
/***********************************/
/***********************************/










/*******************************************************
FUNCTION : init
PURPOSE : Set window
************************************************************/
void  init(void)
{
extern float SIGNAL[2][BSIZE],TIME[BSIZE];
extern float bufy[BSIZE];
extern int N,N2;
int i;
//get and return N,N2
 fp = OPENWAVEFILE ( (ALbyte *)&file, &wave, sizeof(WAVE_Struct));

for(i=0;i<N;i++)
{
SIGNAL[0][i]=0;
SIGNAL[1][i]=0;
bufy[i]=0;
TIME[i]= 0.5*(i*2.0/(N/2) -1);
}

//---smooth line-
glEnable(GL_LINE_SMOOTH);
glEnable(GL_BLEND);
glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
glHint(GL_LINE_SMOOTH_HINT,GL_DONT_CARE);

//----
glClearColor(1.0, 1.0, 1.0, 1.0);// background color to white
gluOrtho2D(-1.,1.,-1.,1.);

//=========================
alutInit(NULL,0);
alGetError();
alGenBuffers(NUMBUFFERS, Buffers);
PREBUFFER();
alGenSources(1,&Source);
SETLOCATION();
alSourceQueueBuffers(Source,NUMBUFFERS,Buffers);
alSourcei(Source,AL_LOOPING,AL_FALSE);
buffersreturned=0;
bFinishedPlaying = AL_FALSE;
buffersinqueue = NUMBUFFERS;
//========================
}
